#pragma once

#include "mapped_file_object_interface.h"
#include "pager.h"
#include "file_paging.h"

/* A pager abstraction for a file. */

class FilePager : public Pager, public MappedFileObject
{
protected:
    FilePaging *_paging;

public:
    fileid_t fileid;

    explicit FilePager(fileid_t fileid, PageMapper *mapper, flags_t flags,
                       FilePaging *paging);

    virtual void close();

    /* Server details. */

    int expected_items();

    ipc_server_handler_type handler();

    void *interface()
    { return static_cast<MappedFileObject *>(this); }

    /* File methods. */

    virtual long flush(offset_t populated_size, offset_t *size);

    virtual long resize(offset_t *size);

    /* Pager and mapped file methods. */

    virtual long map(address_t offset, address_t hot_spot, flags_t flags,
                     l4_snd_fpage_t *region);

    virtual long mmap(offset_t position, offset_t length, offset_t *start_pos,
                      offset_t *end_pos, offset_t *size);
};

// vim: tabstop=4 expandtab shiftwidth=4
