#pragma once

#include <systypes/base.h>

#include <list>
#include <mutex>

#include "memory.h"



/* A memory pool abstraction. */

class MemoryPreallocated : public Memory
{
protected:
    std::mutex _lock;
    std::list<Region *> _regions;

    Memory *_memory;
    length_t _amount;

public:
    explicit MemoryPreallocated(Memory *memory, length_t amount);

    explicit MemoryPreallocated();

    virtual ~MemoryPreallocated();

    virtual Region *region();

    virtual length_t region_size()
    { return _memory->region_size(); }

    virtual void release(Region *region);
};

// vim: tabstop=4 expandtab shiftwidth=4
